lorom

org $808000

!joypad = "$0000"
!apple = "$0004"
!banana = "$0005"
!pineapple = "$0006"
!x_scroll = "$0008"
!y_scroll = "$000a"
!multiplicant_a = "$0010"
!multiplicant_b = "$0012"
!product = "$0014"

!sprite_x = "$02"
!sprite_y = "$04"
!velocity_y = "$06"
!acceleration_y = "$08"
!delayed_control = "$0a"
!collision = "$0c"
!delayed_collision = "$0e"
!direction = "$10"
!control = "$12
!width = "$14"
!height = "$16"
!touch_wall = "$18"
!countdown = "$1a"


!angle = "$06"
!amplitude = "$08"
!sprite2_x = "$0a"
!sprite2_y = "$0c"

!table = "$0080"
!update_flag = "$0100"
!vram = "$0101"
!source = "$0102"
!oam = "$0200"
!oam_hi = "$0400"
!list = "$0500"


macro change_vram(source, vram)
php
rep #$20
sep #$10
lda #<source>
ldy #<vram>
jsr change_slot
plp
endmacro

macro display_sprite(x_coord,y_coord,attributes)
php
rep #$30
lda <x_coord>
ldy <y_coord>
ldx <attributes>
jsr display_sprite
plp
endmacro

macro display_16x32_sprite(x_coord,y_coord,attributes)
php
rep #$30
lda <x_coord>
ldy <y_coord>
ldx <attributes>
jsr display_sprite
pha
tya
clc
adc #$0010
tay
inx #2
pla
jsr display_sprite
plp
endmacro






macro display_48x64_sprite(x_coord,y_coord,attributes)
php
rep #$30
lda <x_coord>
ldy <y_coord>
ldx <attributes>
jsr display_48x64_sprite
plp
endmacro

macro display_reversed_48x64_sprite(x_coord,y_coord,attributes)
php
rep #$30
lda <x_coord>
ldy <y_coord>
ldx <attributes>
jsr display_reversed_48x64_sprite
plp
endmacro



clc			;;some cpu setup stuff
xce
rep #$28
lda #$0000
tcd
lda #$1fff
tcs

sep #$20
cli
lda #$00
pha
plb

rep #$30
ldx #$0000
lda #$0000
clear_ram:
sta $0000,x
inx
inx
cpx #$2000
bne clear_ram

lda #$0080
sta !sprite_y+$1000

lda #$00a0
sta $1104
lda #$0180
sta $1102
lda #girl
sta $1000


lda #rotating_stick
sta $1100
lda #test_object
sta $1200
lda #$0040
sta $1204
lda #$0180
sta $1202
lda #test_object
sta $1300
lda #$0040
sta $1304
lda #$0080
sta $1302
lda #test_object
sta $1400
lda #$0040
sta $1404
lda #$0280
sta $1402
lda #test_object
sta $1500
lda #$0040
sta $1504
lda #$0240
sta $1502
lda #test_object
sta $1600
lda #$0040
sta $1604
lda #$0040
sta $1602
lda #test_object
sta $1700
lda #$0040
sta $1704
lda #$01c0
sta $1702
lda #test_object
sta $1800
lda #$0040
sta $1804
lda #$0300
sta $1802
lda #test_object
sta $1900
lda #$0040
sta $1904
lda #$0380
sta $1902
lda #test_object
sta $1a00
lda #$0040
sta $1a04
lda #$0340
sta $1a02
lda #test_object
sta $1b00
lda #$0040
sta $1b04
lda #$03e0
sta $1b02
lda #test_object
sta $1c00
lda #$0040
sta $1c04
lda #$03d0
sta $1c02



sep #$30


sep #$30
lda $4210
lda #$0f
sta $2100





lda #$80
sta $4207
lda #$00
sta $4208

lda #$01
sta $420d



lda #$00
sta $2121
sta $2121
lda #$ff
sta $2122
sta $2122

rep #$30
ldx #$0000
copy_level_bg_map:
lda $818000,x
sta $7f0000,x
inx #2
cpx #$8000
bne copy_level_bg_map
sep #$30


%change_vram($8090,$40)
%change_vram($8094,$42)
%change_vram($8098,$44)
%change_vram($809c,$46)

%change_vram($80a0,$48)
%change_vram($80a4,$4a)
%change_vram($80a8,$4c)
%change_vram($80ac,$4e)


%change_vram($7f00,$20)


lda #$80
sta $4200


wai







nmi:



clc			;;some cpu setup stuff
xce
rep #$28
lda #$0000
tcd
lda #$1fff
tcs

sep #$20
cli
lda #$00
pha
plb


sep #$30
lda #$80
sta $2100

lda #$01
sta $4200

loop:
lda $4212
and #$01
beq loop
lda $4218
sta !joypad
lda $4219
sta !joypad+1
lda $421a
sta !joypad+2
lda $421b
sta !joypad+3




lda #$80
sta $4207
lda #$00
sta $4208

lda #$01
sta $420d

jsr load_oam

jsr update_vram_slots




lda #$00
sta $2121
sta $2121
lda #$ff
sta $2122
sta $2122
lda #$00
sta $2122
sta $2122
lda #$f0
sta $2122
lda #$0f
sta $2122
lda #$ff
sta $2122
lda #$0e
sta $2122

lda #$80
sta $2121
lda #$ff
sta $2122
sta $2122
lda #$00
sta $2122
sta $2122
lda #$00
sta $2122
lda #$ff
sta $2122
lda #$1f
sta $2122
lda #$66
sta $2122
lda #$1f
sta $2122
lda #$43
sta $2122
lda #$f0
sta $2122
lda #$ff
sta $2122
lda #$ff
sta $2122
lda #$ff
sta $2122




lda #$11
sta $212c

lda #$62
sta $2101

lda #$04
sta $210b
lda #$21
sta $2107
lda #$11
sta $2105
lda !x_scroll
sta $210d
lda !x_scroll+1
sta $210d
stz $210e
stz $210e

lda #$0f
sta $2100

rep #$30
ldx #$0000
stx !pineapple
lda #$f000
clear_oam:
sta !oam,x
inx #4
cpx #$0220
bne clear_oam: 
ldx #$0000
lda #$0000
clear_list:
sta !list+1,x
inx #4
cpx #$0200
bne clear_list:



rep #$30


jsr object_organizer




jsr create_oam_hi

jsr scrolling


sep #$30



lda #$80
sta $4200

wai





change_slot:
cmp !table,y
beq redundant_vram_load
sta !table,y
ldx !apple
sta !source,x
phy
ldy #$01
phy
pla
sta !update_flag,x
inx #4
stx !apple
redundant_vram_load:
rts



update_vram_slots:

php
sep #$30
ldx !banana
ldy #$04
lda #$80
sta $2115
lda #$01
sta $4300
lda #$18
sta $4301


vram_loop:
lda !update_flag,x
beq finish
stz $2116
lda !vram,x
sta $2117
stz $4302
lda !source,x
sta $4303
lda !source+1,x
sta $4304
stz $4305
lda #$04
sta $4306
lda #$01
sta $420b
lda #$00
sta !update_flag,x
inx #4
dey
bne vram_loop
finish:
stx !banana
sep #$30
lda !apple
sec
sbc !banana
cmp #$10
bmi lag
lda #$80
sta $4200
wai
lag:
plp
rts


load_oam:
php
sep #$20
rep #$10
stz $2102
stz $2103
ldx #$0400
stx $4300
ldx #!oam
stx $4302
stz $4304
ldx #$0220
stx $4305
lda #$01
sta $420b
plp
rts

create_oam_hi:

php
rep #$30
ldx #$0000
ldy #$0000
create_oam_hi_loop:
lda !list+29,x
asl #2
ora !list+25,x
asl #2
ora !list+21,x
asl #2
ora !list+17,x
asl #2
ora !list+13,x
asl #2
ora !list+9,x
asl #2
ora !list+5,x
asl #2
ora !list+1,x
sta !oam_hi,y
txa
clc
adc #$0020
tax
iny #2
cpy #$0020
bne create_oam_hi_loop
plp
rts




display_sprite:
pha
phy
phx
ldx !pineapple
sec 
sbc !x_scroll
clc
adc #$0010
cmp #$0110
bcc onscreen_horizontal
lda #$0000
onscreen_horizontal:
sec
sbc #$0010
and #$01ff
sta !oam,x
sta !list,x
tya
clc
adc #$0010
and #$0f00
beq onscreen_vertical
ldy #$00f0
onscreen_vertical:
tya
sta !oam+1,x
lda $01,s
sta !oam+2,x
inx #4
stx !pineapple
plx
ply
pla
rts


display_48x16_sprite:
pha
phx
jsr display_sprite
pha
txa
clc
adc #$0002
tax
pla
clc
adc #$0010
jsr display_sprite
pha
txa
clc
adc #$0002
tax
pla
clc
adc #$0010
jsr display_sprite
plx
pla
rts

display_48x64_sprite:
sec
sbc #$0008
phx
pha
tya
sec
sbc #$0010
tay
pla
jsr display_48x16_sprite
pha
tya
clc
adc #$0010
tay
txa
clc
adc #$0008
tax
pla
jsr display_48x16_sprite
plx
pha
tya
clc
adc #$0010
tay
txa
clc
adc #$0020
tax
pla
jsr display_48x16_sprite
pha
tya
clc
adc #$0010
tay
txa
clc
adc #$0008
tax
pla
jsr display_48x16_sprite
rts

display_reversed_48x16_sprite:
pha
phx
clc
adc #$0020
jsr display_sprite
pha
txa
clc
adc #$0002
tax
pla
sec
sbc #$0010
jsr display_sprite
pha
txa
clc
adc #$0002
tax
pla
sec
sbc #$0010
jsr display_sprite
plx
pla
rts


display_reversed_48x64_sprite:
pha
tya
sec
sbc #$0010
tay
pla
sec
sbc #$0008
phx
jsr display_reversed_48x16_sprite
pha
tya
clc
adc #$0010
tay
txa
clc
adc #$0008
tax
pla
jsr display_reversed_48x16_sprite
plx
pha
tya
clc
adc #$0010
tay
txa
clc
adc #$0020
tax
pla
jsr display_reversed_48x16_sprite
pha
tya
clc
adc #$0010
tay
txa
clc
adc #$0008
tax
pla
jsr display_reversed_48x16_sprite
rts



scrolling:
php
rep #$20
sep #$10
lda !x_scroll
and #$3e00
asl #2
xba
pha
clc
adc #$0008
ora #$7f00
and #$fff0
ldy #$20
jsr change_slot
ora #$0004
ldy #$22
jsr change_slot
pla
ora #$7f08
ldy #$24
jsr change_slot
ora #$0004
ldy #$28
jsr change_slot
plp
rts

tile_collision:
txa
lsr #3
and #$003e
pha
tya
asl #2
and #$07c0
pha
txa
asl #2
and #$f800
ora $01,s
ora $03,s
plx
plx
tax
lda $7f0000,x
tax
lda collision_attributes,x

rts

object_collision:

lda !width
clc
adc !width+$0000,x
pha
lda !sprite_x
clc
adc !width
sec
sbc !sprite_x+$0000,x
cmp $01,s
bcs no_object_collision
pla
lda !height
clc
adc !height+$0000,x
pha
lda !sprite_y
clc
adc !height
sec
sbc !sprite_y+$0000,x
cmp $01,s
bcs no_object_collision
pla
lda #$0001
rts

no_object_collision:

pla
lda #$0000
rts





multiplication:
pha
phx
phy
php
sep #$30
lda !multiplicant_a
sta $211b
lda !multiplicant_a+1
sta $211b
lda !multiplicant_b
sta $211c
sta $211c
lda $2134
sta !product
lda $2135
sta !product+1
lda $2136
sta !product+2
lda !multiplicant_a
sta $211b
lda !multiplicant_a+1
sta $211b
lda !multiplicant_b+1
sta $211c
sta $211c
lda $2134
clc
adc !product+1
sta !product+1
lda $2135
adc !product+2
sta !product+2
lda $2136
adc #$00
sta !product+3
plp
ply
plx
pla
rts

polar_to_rect:
txa
asl
and #$01fe
tax
lda sine,x
sta !multiplicant_a
sty !multiplicant_b
jsr multiplication
lda !product+1
sec
sbc !multiplicant_b
tay
lda cosine,x
sta !multiplicant_a
jsr multiplication
lda !product+1
sec
sbc !multiplicant_b
tax
rts



sine:

dw 256,262,269,275,281,287,294,300,306,312,318,324,330,336,342,348,354,360,365,371,377,382,388,393,398,403,408,413,418,423,428,433,437,441,446,450,454,458,462,465,469,472,476,479,482,485,487,490,493,495,497,499,501,503,504,506,507,508,509,510,511,511,512,512

cosine:

dw 512,512,512,511,511,510,509,508,507,506,504,503,501,499,497,495,493,490,487,485,482,479,476,472,469,465,462,458,454,450,446,441,437,433,428,423,418,413,408,403,398,392,388,382,377,371,365,360,354,348,342,336,330,324,318,312,306,300,294,287,281,275,269,262,256,250,243,237,231,225,218,212,206,200,194,188,182,176,170,164,158,152,147,140,135,130,124,119,114,109,104,99,94,89,84,79,75,71,66,62,58,54,50,47,43,40,36,33,30,27,25,22,19,17,15,13,11,9,8,6,5,4,3,2,1,1,0,0,0,0,0,1,1,2,3,4,5,6,8,9,11,13,15,17,19,22,25,27,30,33,36,40,43,47,50,54,58,62,66,71,75,79,84,89,94,99,104,109,114,119,124,130,135,140,147,152,158,164,170,176,182,188,194,200,206,212,218,225,231,237,243,250,256,262,269,275,281,287,294,300,306,312,318,324,330,336,342,348,354,360,365,371,377,382,388,393,398,403,408,413,418,423,428,433,437,441,446,450,454,458,462,465,469,472,476,479,482,485,487,490,493,495,497,499,501,503,504,506,507,508,509,510,511,511,512,512

object_organizer:
php
rep #$30
lda #$1000
object_loop:
tcd
tax
lda $00
beq no_object
jsr ($0000,x)
no_object:
tdc
clc
adc #$0100
cmp #$2000
bne object_loop:
lda #$0000
tcd
plp
rts


test_object:

lda #$0010
sta !width
lda #$0020
sta !height
lda !touch_wall
beq robot_left


lda !sprite_x
sec
sbc !sprite_x+$1000
bmi robot_right
lda #$0000
sta !direction

robot_right:

lda !sprite_x+$1000
sec
sbc !sprite_x
bmi robot_left
lda #$0001
sta !direction

robot_left:



lda !direction
beq move_robot_right
lda !sprite_x
inc
sta !sprite_x
move_robot_right:

lda !direction
bne move_robot_left
lda !sprite_x
dec
sta !sprite_x
move_robot_left:





jsr physics

lda !touch_wall
xba
lsr
sta !control




ldx #$1000
robot_collision_loop:
phx
tdc
cmp $01,s
beq try_another_object
lda $0000,x
cmp #test_object
bne try_another_object

jsr object_collision
beq try_another_object
jsr object_bumping
try_another_object:
pla
clc
adc #$0100
tax
cmp #$2000
bne robot_collision_loop



lda !direction
bne robot_facing_right

%display_16x32_sprite(!sprite_x,!sprite_y,#$3080)


bra robot_facing_left

robot_facing_right:

%display_16x32_sprite(!sprite_x,!sprite_y,#$7080)

robot_facing_left:





rts

rotating_stick:


lda !angle
inc
sta !angle
lda #$0010
sta !amplitude
lda #$0140
sta !sprite_x
lda #$00b0
sta !sprite_y

%display_sprite(!sprite_x,!sprite_y,#$3080)


make_stick:

ldx !angle
ldy !amplitude
jsr polar_to_rect
txa
clc
adc !sprite_x
sta !sprite2_x
tya
clc
adc !sprite_y
sta !sprite2_y

%display_sprite(!sprite2_x,!sprite2_y,#$3080)

lda !amplitude
clc
adc #$0010
sta !amplitude
cmp #$0070

bne make_stick

rts

girl:


lda #$0020
sta !width
lda #$0030
sta !height

lda !joypad
sta !control

lda !countdown
beq do_not_dash

lda !control
and #$0040
beq do_not_dash
jmp dash
do_not_dash:


%change_vram($8098,$44)
%change_vram($809c,$46)

lda !control
and #$0040
bne do_not_let_her_dash

lda #$0020
sta !countdown

do_not_let_her_dash:

lda !control
and #$0100
beq move_right
lda !sprite_x
inc #3
sta !sprite_x
lda #$0000
sta !direction
move_right:


lda !control
and #$0200
beq move_left
lda !sprite_x
dec #3
sta !sprite_x
lda #$0001
sta !direction
move_left:

jsr physics



display_girl:

lda !sprite_x
sec
sbc #$0040
bpl camera_left_limit
lda #$0000
camera_left_limit:
cmp #$0300
bmi camera_right_limit
lda #$0300
camera_right_limit:
sta !x_scroll


lda !direction
beq facing_right

%display_reversed_48x64_sprite(!sprite_x,!sprite_y,#$7040)

bra facing_left

facing_right:

%display_48x64_sprite(!sprite_x,!sprite_y,#$3040)

facing_left:

rts

dash:
%change_vram($80a4,$44)
%change_vram($80a8,$46)
lda !direction
beq dash_right
lda !sprite_x
sec
sbc #$000c
sta !sprite_x
bra dash_left
dash_right:
lda !sprite_x
clc
adc #$000c
sta !sprite_x
dash_left:

jsr wall_collision

lda !countdown
dec
sta !countdown


jmp display_girl










physics:

lda !velocity_y
cmp #$8000
bpl clamp_velocity
cmp #$0040
bmi clamp_velocity
lda #$0040
sta !velocity_y


clamp_velocity:



lda !velocity_y
clc
adc !acceleration_y
sta !velocity_y
lsr #2
clc
adc !sprite_y
and #$0fff
sta !sprite_y

lda !velocity_y
cmp #$8000
bpl collision

ldx !sprite_x
lda !sprite_y
clc
adc !height
tay
jsr tile_collision
sta !collision

lda !sprite_x
clc
adc !width
dec
tax
lda !sprite_y
clc
adc !height
tay
jsr tile_collision
ora !collision
sta !collision

tax
lda !acceleration_y
beq not_falling
lda !collision
eor !delayed_collision
and !collision
tax
not_falling:

txa
and #$0008
beq no_collision
lda #$0000
sta !velocity_y
sta !acceleration_y
lda !sprite_y
and #$fff0
sta !sprite_y

lda !control
eor !delayed_control
and !control
and #$0080
beq jump
lda #$ffd4
sta !velocity_y
lda #$0003
sta !acceleration_y
jump:
bra collision

no_collision:
lda #$0001
sta !acceleration_y

collision:


wall_collision:

lda #$0000
sta !touch_wall



lda !sprite_x
clc
adc !width
tax
lda !sprite_y
clc
adc !height
dec
tay
jsr tile_collision


and #$0002
beq left_wall
lda !sprite_x
and #$fff0
sta !sprite_x
lda #$0001
sta !touch_wall

left_wall:



ldx !sprite_x
lda !sprite_y
clc
adc !height
dec
tay
jsr tile_collision

and #$0001
beq right_wall
lda !sprite_x
and #$fff0
clc
adc #$0010
sta !sprite_x

lda #$0001
sta !touch_wall


right_wall:

lda !control
sta !delayed_control

lda !collision
sta !delayed_collision

rts



object_bumping:

lda !sprite_x
cmp !sprite_x+$0000,x
bcc bounce_right
lda #$0001
sta !direction
rts

bounce_right:
lda #$0000
sta !direction
rts





collision_attributes:

dw $0000,$0008,$0008,$0008,$000a,$0009,$0002,$0001
dw $0000,$0008,$0008,$0008,$000a,$0009,$0002,$0001
dw $0000,$0008,$0008,$0008,$000a,$0009,$0000,$0000
dw $0000,$0008,$0008,$0008,$000a,$0009,$0000,$0000





org $80ffea

dw nmi,$8000

org $80fffa

dw nmi,$8000



org $818000

dw 14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
dw 14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
dw 14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
dw 14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
dw 14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
dw 14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
dw 14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,36,36,36,36,36,36,36,6,0,0,0,0
dw 14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,32,32,32,32,32,0,0,0,0,0
dw 14,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,32,32,32,32,32,0,0,0,0,0
dw 14,0,0,0,2,36,36,6,0,0,0,0,0,0,0,0,0,0,0,0,32,32,32,32,34,36,36,36,36,6,0,0
dw 14,0,0,0,0,32,32,0,0,0,0,8,36,10,0,0,0,0,0,0,32,32,32,32,32,32,32,32,32,0,0,0
dw 14,0,0,0,0,32,32,0,0,0,0,12,32,14,0,0,0,0,0,0,32,32,32,32,32,32,32,32,32,0,0,0
dw 46,36,36,36,36,36,36,36,36,36,36,44,32,46,36,36,36,36,36,36,36,36,36,36,36,36,36,36,36,36,36,36
dw 32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32
dw 32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32
dw 32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32


org $818800

dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12
dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12
dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12
dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12
dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12
dw 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,12
dw 0,0,0,0,0,0,0,0,0,0,2,36,36,36,36,36,36,36,36,36,36,36,36,36,36,36,36,6,0,0,0,12
dw 0,0,0,0,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,0,0,0,0,12
dw 0,0,0,0,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,0,0,0,0,12
dw 0,0,0,0,2,36,36,6,0,0,0,32,32,32,32,32,32,32,32,32,32,32,32,32,34,36,36,36,36,6,0,12
dw 0,0,0,0,0,32,32,0,0,0,0,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,0,0,12
dw 0,0,0,0,0,32,32,0,0,0,0,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,0,0,12
dw 36,10,0,0,0,32,32,0,0,0,0,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,0,0,12
dw 32,46,36,36,36,36,36,36,36,36,36,36,36,36,36,36,36,36,36,36,36,36,36,36,36,36,36,36,36,36,36,44
dw 32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32
dw 32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32
